
window._APP_CAMERA_PERMISSION = false;
window._APP_LIBRARY_PERMISSION = false;
window._APP_NOTIFICATION_PERMISSION = false;
window._APP_LOCATION_PERMISSION = {
    lat: '',
    lng: ''
};
window._APP_FCM_TOKEN = ""
window._APP_NATIVE_VERSION = ""
window._APP_DEVICE_KEY = ""
window._APP_PLATFORM = ""
window._APP_AGENT = ""
window._APP_TYPE = ""
window._APP_LOC = ""
window._APP_LANG = ""
window.IDLE_TIME = 0
window._APP_PHONE_NUMBER = ""
window._APP_SNS = {
    type:'',
    data:''
}

window.nativeResponseAppDevice = function (data) {
    try{
        console.log("nativeResponseAppDevice", data)
        window._APP_FCM_TOKEN = data.fcmToken || "NON-FCM-TOKEN"
        window._APP_NATIVE_VERSION = data.appVersion || "1.0.0"
        window._APP_DEVICE_KEY = data.deviceKey
        window._APP_PLATFORM = data.platform.toLowerCase() || "OTHER"
        window._APP_AGENT = data.agent
        window._APP_TYPE = "USER" //data?.type || 
        window._APP_LOC = "VN" //data.loc || "VN" 
        const _appLangCode = data?.lang && ['vi', 'ko', 'en', 'th', 'my', 'id', 'ja', 'zh'].includes(data?.lang.toLocaleLowerCase()) ? data?.lang.toLocaleLowerCase() : 'ko'
        window._APP_LANG = _appLangCode  //data?.lang ||  "vi"
    } catch (e) {
        console.log("nativeResponseAppDevice", e)
    }
}

window.webViewRequestTerminateSplash = function () {
    return new Promise((resolve) => {
        console.log("webViewRequestTerminateSplash")
        try{
            if (window.AndroidApp) {
                window.AndroidApp.webViewRequestTerminateSplash();
            } else if (window.webkit && window.webkit.messageHandlers) {
                window.webkit.messageHandlers.webViewRequestTerminateSplash.postMessage("");
            }
            resolve(true)
        } catch (e) {
            console.log("webViewRequestTerminateSplash", e)
        }
        resolve(true)
    })
}

window.webViewDocumentReady = function () {
    return new Promise((resolve) => {
        try{

            if (window.AndroidApp) {
                window.AndroidApp.webViewDocumentReady();
            } else if (window.webkit && window.webkit.messageHandlers) {
                window.webkit.messageHandlers.webViewDocumentReady.postMessage("");
            } else{
                window._APP_PLATFORM = "NONE"
            }
            resolve(true)
        } catch (e) {
            console.log("webViewLoaded", e)
            window._APP_PLATFORM = "NONE"
        }
        resolve(true)
    })

}

window.webViewResponseUserInfo = function (data) {
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webViewResponseUserInfo(JSON.stringify(data));
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webViewResponseUserInfo.postMessage(JSON.stringify(data));
        }
    } catch (e) {
        console.log("webViewResponseUserInfo", e)
    }
}

window.webViewRequestClearCache = function (line = null) {
    try{
        console.log("webViewRequestClearCache", line)
        if (window.AndroidApp) {
            window.AndroidApp.webViewRequestClearCache();
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webViewRequestClearCache.postMessage("");
        }
    } catch (e) {
        console.log("webViewResponseUserInfo", e)
    }
}

window.webViewRequestLogout = function (token) {
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webViewRequestLogout(token);
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webViewRequestLogout.postMessage(token);
        }
    } catch (e) {
        console.log("webViewRequestLogout", e)
    }
}

window.webViewRequestPhoneDial = function (phone) {
    console.log(78, phone);
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webViewRequestPhoneDial(phone);
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webViewRequestPhoneDial.postMessage(phone);
        }
    } catch (e) {
        console.log("webViewRequestPhoneDial", e)
    }
}

window.webViewRequestKakaoChannel = function (kakaoId) {
    console.log(90, kakaoId);
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webViewRequestKakaoChannel(kakaoId);
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webViewRequestKakaoChannel.postMessage(kakaoId);
        }
    } catch (e) {
        console.log("webViewRequestPhoneDial", e)
    }
}

window.webViewRequestShare = function (data) {
    try{
        console.log(data);
        if (window.AndroidApp) {
            window.AndroidApp.webViewRequestShare(data);
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webViewRequestShare.postMessage(data);
        }
    } catch (e) {
        console.log("webViewRequestShare", e)
    }
}

window.webViewRequestPermission = function (perms) {
    try{
        const _perms = perms.join(",")
        // alert(_perms)
        console.log("webViewRequestPermission", _perms)
        // document.getElementById("debugPanel").innerText = _perms
        if (window.AndroidApp) {
            window.AndroidApp.webViewRequestPermission(_perms);
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webViewRequestPermission.postMessage(JSON.stringify(_perms));
        }
    } catch (e) {
        console.log("window.webViewRequestPermission", e)
    }
}
window.webViewRequestPermissionCheck = function () {
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webViewRequestPermission();
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webViewRequestPermission.postMessage();
        }
    } catch (e) {
        console.log("webViewRequestCameraPermission", e)
    }
}

window.nativeResponsePermission = (data) => {
    console.log('nativeResponsePermission', data)
    if (window?._nativeResponsePermission) {
        window?._nativeResponsePermission(data)
    }
    if (data.camera) {
        window._APP_CAMERA_PERMISSION = data.camera;
    }
    if (data.library) {
        window._APP_LIBRARY_PERMISSION = data.library;
    }
    if (data.notification) {
        window._APP_NOTIFICATION_PERMISSION = data.notification;
    }
    if (data.location) {
        window._APP_LOCATION_PERMISSION = {
            lat: +data?.location?.lat || null,
            lng: +data?.location?.lng || null,
        }
    }
}

window.webViewRequestShowToast = function (data) {
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webViewRequestShowToast(JSON.stringify(data));
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webViewRequestShowToast.postMessage(JSON.stringify(data));
        }
    } catch (e) {
        console.log("webViewRequestShowToast", e)
    }
}

window.nativeWebviewResume = function (data) {
    try{
        console.log("nativeWebviewResume", data)
        window.IDLE_TIME = data.idleTime
    } catch (e) {
        console.log("nativeWebviewResume", e)
    }
}

window.nativeWebviewIdle = function (data) {
    try{
        console.log("nativeWebviewIdle", data)
        
    } catch (e) {
        console.log("nativeWebviewIdle", e)
    }
}

window.webViewCallGetListPath = function (data) {
    try{
        console.log('webViewCallGetListPath', data)
        if (window.AndroidApp) {
            window.AndroidApp.webViewCallGetListPath(data);
        }
    } catch (e) {
        console.log("webViewRequestShowToast", e)
    }
}
  
window.nativeCallDirectUrl = function(url){
    console.log(182, url);
}

window.webViewOpenBrowser = function(url){
    console.log('webViewOpenBrowser', url);
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webViewOpenBrowser(url);
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webViewOpenBrowser.postMessage(url);
        }
    } catch (e) {
        console.log("webViewOpenBrowser errors", e)
    }
}

window.webViewSendOrderId = function(id){
    console.log('webViewSendOrderId', id);
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webViewSendOrderId(id);
        }
    } catch (e) {
        console.log("webViewOpenBrowser errors", e)
    }
}

window.webViewRequestOpenMarket = function(url){
    console.log('webViewRequestOpenMarket', url);
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webViewRequestOpenMarket(url);
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webViewRequestOpenMarket.postMessage(url);
        }
    } catch (e) {
        console.log("webViewRequestOpenMarket errors", e)
    }
}

window.webviewRequestTakePhoto = function(callType, fileType, dirType){
    const data = { callType, fileType, dirType };
    console.log('webviewRequestTakePhoto', JSON.stringify(data));
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webviewRequestTakePhoto(JSON.stringify(data));
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webviewRequestTakePhoto.postMessage(data);
        }
    } catch (e) {
        console.log("webviewRequestTakePhoto errors", e)
    }
}

// {callType: "MULTIPLE", fileType: "IMAGE", dirType: "USER,RECIPE_DETAIL,INGREDIENT,TEMPORARY"}
window.webviewRequestChooseFile = function(callType, fileType, dirType){
    const data = { callType, fileType, dirType };
    console.log('webviewRequestChooseFile', JSON.stringify(data));
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webviewRequestChooseFile(JSON.stringify(data));
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webviewRequestChooseFile.postMessage(data);
        }
    } catch (e) {
        console.log("webviewRequestChooseFile errors", e)
    }
}

window.nativeResponseFileUploading = function (data) {
    console.log("nativeResponseFileUploading", data);
    
    try{
        if (Array.isArray(data) && typeof data[0] === 'string') {
            data = data.map(e => JSON.parse(e))
        }
        console.log("nativeResponseFileUploading", data)
        if (window._nativeResponseFileUploading) {
            window._nativeResponseFileUploading(data)
        }

        return window.FILE_PROCESSING = data
    } catch (e) {
        console.log("nativeResponseFileUploading", e)
    }
}

window.nativeResponseFileSuccess = function (data) {
    console.log("nativeResponseFileSuccess", data)
    try{
        if (typeof data === 'string') {
            data = JSON.parse(data)
        }
        console.log("nativeResponseFileSuccess", data)
        if (window._nativeResponseFileSuccess) {
            window._nativeResponseFileSuccess(data)
        }

        return window.FILE_SUCCESS = data
    } catch (e) {
        console.log("nativeResponseFileSuccess", e)
    }
}

window.nativeResponseFileFail = function (uuid) {
    try{
        console.log("nativeResponseFileFail", uuid)
        if (window._nativeResponseFileFail) {
            window._nativeResponseFileFail(uuid)
        }

    } catch (e) {
        console.log("nativeResponseFileFail", e)
    }
}

window.nativeResponseFileCancel = function (uuid) {
    try{
        console.log("nativeResponseFileCancel", uuid)
        if (window._nativeResponseFileCancel) {
            window._nativeResponseFileCancel(uuid)
        }

    } catch (e) {
        console.log("nativeResponseFileCancel", e)
    }
}

window.webViewRequestRetryUpload = function (uuid) {
    try{
        console.log("webViewRequestRetryUpload", uuid)
        if (window.AndroidApp) {
            window.AndroidApp.webViewRequestRetryUpload(uuid);
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webViewRequestRetryUpload.postMessage(uuid);
        }
    } catch (e) {
        console.log("webViewRequestRetryUpload errors", e)
    }
}

// {filename: "filename", url: "xxxx"}
window.webViewRequestDownload = function(filename, url){
    // const data = {callType: "MULTIPLE", fileType: "IMAGE", dirType: "PROPERTY"}
    console.log('webViewRequestDownload', {filename, url});
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webViewRequestDownload(filename, url);
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webViewRequestDownload.postMessage({filename, url});
        }
    } catch (e) {
        console.log("webViewRequestDownload errors", e)
    }
}

window.webviewRequestPhoneNumber = function(){
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webviewRequestPhoneNumber();
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webviewRequestPhoneNumber.postMessage({});
        }
    } catch (e) {
        console.log("webviewRequestPhoneNumber errors", e)
    }
}

window.webviewRequestOTP = function(){
    console.log('webviewRequestOTP');
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webviewRequestOTP();
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webviewRequestOTP.postMessage({});
        }
    } catch (e) {
        console.log("webviewRequestOTP errors", e)
    }
}

window.webViewRequestOpenGoogleMaps = function(data){
    console.log('webViewRequestOpenGoogleMaps', data);
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webViewRequestOpenGoogleMaps(JSON.stringify(data));
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webViewRequestOpenGoogleMaps.postMessage(JSON.stringify(data));
        }
    } catch (e) {
        console.log("webViewRequestOpenGoogleMaps errors", e)
    }
}

window.webViewRequestScanQRCode = function(uuid){
    // const data = {callType: "MULTIPLE", fileType: "IMAGE", dirType: "PROPERTY"}
    console.log('webViewRequestScanQRCode', {uuid});
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webViewRequestScanQRCode(uuid);
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webViewRequestScanQRCode.postMessage(uuid);
        }
    } catch (e) {
        console.log("webViewRequestScanQRCode errors", e)
    }
}


window.nativeResponseScanQRCode = function (data) {
    try{
        if (typeof data === 'string') {
            const _data = JSON.parse(data)
            window._APP_QR_SCANDATA = _data
        }
        if (typeof data === "object") {
            window._APP_QR_SCANDATA = data
        }
    } catch (e) {
        console.log("nativeResponseScanQRCode", e)
    }
}

window.webviewRequestSNSLogin = function(data){
    console.log('webviewRequestSNSLogin',data);
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webviewRequestSNSLogin(JSON.stringify(data));
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webviewRequestSNSLogin.postMessage(data);
        }
    } catch (e) {
        console.log("webviewRequestSNSLogin errors", e)
    }
}

window.webviewResponeLanguage = function(data){
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webviewResponeLanguage(JSON.stringify(data));
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webviewResponeLanguage.postMessage(JSON.stringify(data));
        }
    } catch (e) {
        console.log("webviewResponeLanguage errors", e)
    }
}

window.nativeResponseSNSData = function (data) {
    try{
        console.log("nativeResponseSNSData", data)
        window._APP_SNS = {
            type: data.type || '',
            data: data.data || '',
        }
    } catch (e) {
        console.log("nativeResponseSNSData", e)
    }
}

window.webViewRequestPlayerVideo = function(url, videoId){
    console.log('webViewRequestPlayerVideo', url, videoId);
    try{
        if (window.AndroidApp) {
            window.AndroidApp.webViewRequestPlayerVideo(url, videoId);
        } else if (window.webkit && window.webkit.messageHandlers) {
            window.webkit.messageHandlers.webViewRequestPlayerVideo.postMessage({url, videoId});
        }
    } catch (e) {
        console.log("webViewRequestPlayerVideo errors", e)
    }
}
